---
title: Array.prototype.splice()
slug: Web/JavaScript/Reference/Global_Objects/Array/splice
tags:
  - Array
  - JavaScript
  - Method
  - Prototype
  - Reference
  - remove
  - replace
  - splice
---
<div>{{JSRef}}</div>

<p>The <strong><code>splice()</code></strong> method changes the contents of an array by removing or replacing existing elements and/or adding new elements <a href="https://en.wikipedia.org/wiki/In-place_algorithm">in place</a>.</p>

<div>{{EmbedInteractiveExample("pages/js/array-splice.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <var>arrDeletedItems</var> = <var>array</var>.splice(<var>start</var>[, <var>deleteCount</var>[, <var>item1</var>[, <var>item2</var>[, ...]]]])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>start</var></code></dt>
 <dd>The index at which to start changing the array.</dd>
 <dd>If greater than the length of the array, <code><var>start</var></code> will be set to the length of the array. In this case, no element will be deleted but the method will behave as an adding function, adding as many element as item[n*] provided.</dd>
 <dd>If negative, it will begin that many elements from the end of the array. (In this case, the origin <code>-1</code>, meaning <code>-<var>n</var></code> is the index of the <code><var>n</var></code><sup>th</sup> last element, and is therefore equivalent to the index of <code><var>array</var>.length - <var>n</var></code>.) If <code><var>array</var>.length + <var>start</var></code> is less than <code>0</code>, it will begin from index <code>0</code>.</dd>
 <dt><code><var>deleteCount</var></code> {{optional_inline}}</dt>
 <dd>An integer indicating the number of elements in the array to remove from <code><var>start</var></code>.</dd>
 <dd>If <code><var>deleteCount</var></code> is omitted, or if its value is equal to or larger than <code><var>array</var>.length - <var>start</var></code> (that is, if it is equal to or greater than the number of elements left in the array, starting at <code><var>start</var></code>), then all the elements from <code><var>start</var></code> to the end of the array will be deleted.</dd>
 <dd>
 <div class="notecard note">
 <p><strong>Note:</strong> In IE8, it won't delete all when <code><var>deleteCount</var></code> is omitted.</p>
 </div>
 </dd>
 <dd>If <code><var>deleteCount</var></code> is <code>0</code> or negative, no elements are removed. In this case, you should specify at least one new element (see below).</dd>
 <dt><code><var>item1</var>, <var>item2</var>, ...</code> {{optional_inline}}</dt>
 <dd>The elements to add to the array, beginning from <code><var>start</var></code>. If you do not specify any elements, <code>splice()</code> will only remove elements from the array.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An array containing the deleted elements.</p>

<p>If only one element is removed, an array of one element is returned.</p>

<p>If no elements are removed, an empty array is returned.</p>

<h2 id="Description">Description</h2>

<p>If the specified number of elements to insert differs from the number of elements being removed, the array's <code>length</code> will be changed.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Remove_0_zero_elements_before_index_2_and_insert_drum">Remove 0 (zero) elements before index 2, and insert "drum"</h3>

<pre class="brush: js notranslate">let myFish = ['angel', 'clown', 'mandarin', 'sturgeon']
let removed = myFish.splice(2, 0, 'drum')

// myFish is ["angel", "clown", "drum", "mandarin", "sturgeon"]
// removed is [], no elements removed</pre>

<h3 id="Remove_0_zero_elements_before_index_2_and_insert_drum_and_guitar">Remove 0 (zero) elements before index 2, and insert "drum" and "guitar"</h3>

<pre class="brush: js notranslate">let myFish = ['angel', 'clown', 'mandarin', 'sturgeon']
let removed = myFish.splice(2, 0, 'drum', 'guitar')

// myFish is ["angel", "clown", "drum", "guitar", "mandarin", "sturgeon"]
// removed is [], no elements removed
</pre>

<h3 id="Remove_1_element_at_index_3">Remove 1 element at index 3</h3>

<pre class="brush: js notranslate">let myFish = ['angel', 'clown', 'drum', 'mandarin', 'sturgeon']
let removed = myFish.splice(3, 1)

// myFish is ["angel", "clown", "drum", "sturgeon"]
// removed is ["mandarin"]
</pre>

<h3 id="Remove_1_element_at_index_2_and_insert_trumpet">Remove 1 element at index 2, and insert "trumpet"</h3>

<pre class="brush: js notranslate">let myFish = ['angel', 'clown', 'drum', 'sturgeon']
let removed = myFish.splice(2, 1, 'trumpet')

// myFish is ["angel", "clown", "trumpet", "sturgeon"]
// removed is ["drum"]</pre>

<h3 id="Remove_2_elements_from_index_0_and_insert_parrot_anemone_and_blue">Remove 2 elements from index 0, and insert "parrot", "anemone" and "blue"</h3>

<pre class="brush: js notranslate">let myFish = ['angel', 'clown', 'trumpet', 'sturgeon']
let removed = myFish.splice(0, 2, 'parrot', 'anemone', 'blue')

// myFish is ["parrot", "anemone", "blue", "trumpet", "sturgeon"]
// removed is ["angel", "clown"]</pre>

<h3 id="Remove_2_elements_from_index_2">Remove 2 elements from index 2</h3>

<pre class="brush: js notranslate">let myFish = ['parrot', 'anemone', 'blue', 'trumpet', 'sturgeon']
let removed = myFish.splice(2, 2)

// myFish is ["parrot", "anemone", "sturgeon"]
// removed is ["blue", "trumpet"]</pre>

<h3 id="Remove_1_element_from_index_-2">Remove 1 element from index -2</h3>

<pre class="brush: js notranslate">let myFish = ['angel', 'clown', 'mandarin', 'sturgeon']
let removed = myFish.splice(-2, 1)

// myFish is ["angel", "clown", "sturgeon"]
// removed is ["mandarin"]</pre>

<h3 id="Remove_all_elements_from_index_2">Remove all elements from index 2</h3>

<pre class="brush: js notranslate">let myFish = ['angel', 'clown', 'mandarin', 'sturgeon']
let removed = myFish.splice(2)

// myFish is ["angel", "clown"]
// removed is ["mandarin", "sturgeon"]</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.splice', 'Array.prototype.splice')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.splice")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.push()", "push()")}} / {{jsxref("Array.prototype.pop()", "pop()")}}— add/remove elements from the end of the array</li>
 <li>{{jsxref("Array.prototype.unshift()", "unshift()")}} / {{jsxref("Array.prototype.shift()", "shift()")}}— add/remove elements from the beginning of the array</li>
 <li>{{jsxref("Array.prototype.concat()", "concat()")}}— returns a new array comprised of this array joined with other array(s) and/or value(s)</li>
</ul>
